# stuff to be implemented externally:
Source10: kmodtool
%define   kmodtool sh %{SOURCE10}
# end stuff to be ...

# if kversion isn't defined on rpm build line, build against current kernel
%{!?kversion: %define kversion %(uname -r)}

# hint: this can he overridden with "--define kversion foo" on the rpmbuild command line, e.g.
# --define "kversion 2.6.16-1.2096_FC5"

%define kmod_name xfs
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""

%ifarch i686
%define smpvar smp
%define hugememvar hugemem
%define xenvar xenU
%endif

%ifarch x86_64
%define smpvar smp
%define largesmpvar largesmp
%define xenvar xenU
%endif

%ifarch sparc64 ppc s390 s390x
%define smpvar smp
%endif

%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?xenvar} %{?paevar} %{?kdumpvar} %{?hugememvar} %{?largesmpvar}}

# hint: this can he overridden with "--define kvariants foo bar" on the rpmbuild command line, e.g.
# --define 'kvariants "" smp' 

Name:           %{kmod_name}-kmod
Version:        0.4
Release:        2.el4.%(echo %{kverrel} | tr - _)
Summary:        %{kmod_name} kernel modules
Packager:	Eric Sandeen <sandeen-centos@sandeen.net>

Group:          System Environment/Kernel
License:        GPL
URL:            http://oss.sgi.com/projects/xfs
Source0		: %{kmod_name}-kern.tar.gz

Source1		: config.xfs

# Allow the code to build as an out-of-tree module
Patch0		: xfs_ootbuild.patch

# Update patches from the sles9 kernel since first release
Patch1          : xfs-kern-202363a-fix-xfs_finish_reclaim_all-umount-deadlock
Patch2          : xfs-log-diag
Patch3          : xfs-kern-25238a-quota-trans-diag
Patch4          : xfs-ftruncate-stale-data
Patch5          : xfs-kern-930841-default_acl_enospc_fix
Patch6          : xfs-kern-25687a-sles9sp3-iunpin-reclaim-fix
Patch7          : xfs-kern-26040a-do-not-dirty-inode-being-freed
Patch8          : xfs-kern-26347a-fix-race-on-link

# This patchset is for making the xfs codebase in sles9 work
# with an RHEL4 kernel.
Patch100        : xfs-version.patch
Patch101        : xfs_qsort.patch
Patch102        : xfs_proc_args.patch
Patch103        : xfs_export_ops.patch
Patch104        : xfs_write_inode_return.patch
Patch105        : xfs_dmapi_address_space.patch
# Needed for kernels < 2.6.9-42.EL, uncomment below
Patch106        : xfs_direct_io_locking.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

ExclusiveArch:  i586 i686 x86_64 ppc ia64 sparc64 ppc64

%description
The XFS(tm) Filesystem from Silicon Graphics, Inc.
XFS is a highly scalable, high-performance journaling filesystem that provides 
rapid recovery from system crashes.

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}


%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0
#pushd %{kmod_name}-%{version}
pushd %{kmod_name}
cp %{SOURCE1} .
# build glue
%patch0 -p1

%patch1 -p3
%patch2 -p3
%patch3 -p3
%patch4 -p3
%patch5 -p3
%patch6 -p3
%patch7 -p3
%patch8 -p3

%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
#%%patch106 -p1

echo "#define XFS_VERSION_STRING \"SGI XFS from %{name}-%{version}-%{release} rpm\"" > linux-2.6/xfs_module_version.h

popd
for kvariant in %{kvariants} ; do
#    cp -a %{kmod_name}-%{version} _kmod_build_${kvariant}
    cp -a %{kmod_name} _kmod_build_${kvariant}
done


%build
for kvariant in %{kvariants}
do
    #ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    ksrc=/lib/modules/"%{kverrel}${kvariant:+$kvariant}"/build
    cd _kmod_build_$kvariant
    #make TOPDIR=${ksrc} modules %{?_smp_mflags}
    make TOPDIR=${ksrc} modules %{?_smp_mflags}
    #make -C "${ksrc}" OOT_BUILD=y SUBDIRS=${PWD} modules %{?_smp_mflags}
    cd ..
done


%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}
do
    #ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    ksrc=/lib/modules/"%{kverrel}${kvariant:+$kvariant}"/build
    cd _kmod_build_$kvariant
    make -C ${ksrc} OOT_BUILD=y SUBDIRS=`pwd` modinst_dir=$RPM_BUILD_ROOT//lib/modules/"%{kverrel}${kvariant:+$kvariant}"/extra/%{kmod_name}  modules_install
    # make TOPDIR=${ksrc} INSTALL_MOD_PATH=$RPM_BUILD_ROOT INSTALL_MOD_DIR=extra/%{kmod_name}/ modules_install %{?_smp_mflags}
    cd ..
    #make install \
    #     DESTDIR=$RPM_BUILD_ROOT
    #     INST_DIR=$RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}
done
# Temporarily executable for stripping, fixed later in %%files.
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/${kmod_name}/*


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Thu May 22 2008 Tru Huynh <tru@centos.org> - 0.4-2
- noop added XFS related comment from kernel-module-xfs 
  Tue Nov 13 2006 - sandeen-centos@sandeen.net
-- removed xfs_direct_io_locking.patch, RHEL4U4 has the fix now.
-- Update to xfs codebase from SLES9_SP3_BRANCH_20061107171129
-- xfs-kern-26347a-fix-race-on-link: fix race on link
   (191713, SGI:PV953287).
-- xfs-kern-26040a-do-not-dirty-inode-being-freed:
   Don't dirty the inode if it being freed in xfs_iunpin (179117,
   SGI:PV952967).
-- xfs-kern-25687a-sles9sp3-iunpin-reclaim-fix: Fix
   an inode use-after-free during an unpin (SGI:PV946321, 142533).
-- xfs-kern-930841-default_acl_enospc_fix:
   Default acl ENOSPC fix (133990, SGI:PV930841).
-- xfs-kern-25238a-quota-trans-diag: quota trans diag
   (131262, SGI:PV931456).
-- xfs-ftruncate-stale-data: XFS ftruncate() bug
   could expose stale data (151055).
-- xfs-log-diag: log_runout_diagnostics (131262,
   SGI:PV947110).
-- xfs-kern-202363a-fix-xfs_finish_reclaim_all-umount-deadlock:
   fix xfs_finish_reclaim_all umount deadlock (132358,
   SGI:PV943821).

* Tue May 22 2007 Johnny Hughes  <johnny@centos.org> 0.4-1
- Modified this version of the spec to work with el4.

* Thu Apr 19 2007 Johnny Hughes <johnny@centos.org> 0.3-2
- Modified kmodtool (Source10) to remove the requirement for xfs-kmod-common
 
* Tue Apr 17 2007 Johnny Hughes <johnny@centos.org>
- Initial use in CentOS-5
- Added paevar and modified paevar, smpvar, xenvar, xdumpvar to follow
  EL5 and not FC6 naming conventions.

